


//Indywidualna tabela predkoci ???s


//Nie dziaa zmiana kierunku gdy zablokowane przyspieszanie i zwalnianie przez wykomentowanie w kodzie
//Przyczyna pewnie jest BlkSpeed
//BlkSpeed realizowac tylko gdy predkosc bya wieksza niz 32 i zmniejszya sie do 0, w przeciwnym, wypadku normalna reakcja


//FUSE:
// OSC:		Int RC 8MHz 0ms
// BOD:		Level 2,7
//ESAVE:	enable
//WDTON:	enble


#define DivTim	8									// Podstawa czasu (8ms)
#define NtstADIF									// Nie testjemy gotowoci przetwornika AC



//*******************************************************************************//
//
//WAVE:
//	http://ccrma.stanford.edu/courses/422/projects/WaveFormat/
//
//Tryb Serwisowy:
//	http://www.forum.martel.pl/viewtopic.php?p=31076
//	tryb serwisowy jest opisany w:
//	http://www.dcc.info/standards_rps/rp923.html
//	http://www.dcc.info/standards_rps/RP-923.pdf
//*******************************************************************************//



//*******************************************************************************//
//* 				Pliki doczane												*//
//*******************************************************************************//
#include <stdlib.h>									// Standardowa C
#include <avr/io.h>									// IO
#include <avr/sfr_defs.h>							// SFR, _BV(bit)
#include <avr/pgmspace.h>							// Flash
#include <avr/interrupt.h>							// wektory IRQ
#include <avr/wdt.h> 								// WDG
#include <avr/eeprom.h>								// Eeprom
#include <compat/deprecated.h>						// sbi, cbi, inb, outb, outp
//#include <math.h> 								// Zmiennoprzecinkowe
//#include <util/setbaud.h>							// Uart
//#include <util/crc16.h>							// Crc16, Xmodem, Dallas
#define ebi(port,bit) ( port ^= (1 << (bit)))		// Negowanie bitu na porcie
#define CODE PROGMEM								// Stale w Flash dla parametru CODE i PROGMEM
#define NOINIT __attribute__ ((section(".noinit")))


//*******************************************************************************//
//* 				Definicje													*//
//*******************************************************************************//



//------------------------------------------------------------------------------//
// V10	- dekoder ATtiny85 DIP													//
// V11	- dekoder ATtiny85 SMD, zamienione jedno wejce Rail, DIR i F0			//
//------------------------------------------------------------------------------//
#define DccVersion	11								// Wersja Dekodera


//------------------------------------------------------------------------------//
// 0 - dekoder trakcji (lokomotyw)												//
// 1 - dekoder akcesorii					 									//
//		wejcie w tryb serwisowy: dodatkowo naciniety trzycisk SERVICE na dekoderze
//		wyjcie trakcji moe sterowa silnikiem w zwrotnicy
//------------------------------------------------------------------------------//
#define Accesory	1


//------------------------------------------------------------------------------//
//CV1 - Adres lekomotywy
// Parowz May			- 4														//
// Parowz OHIO			- 5														//
// Spalinwka niebieska	- 6														//
// Spalinwka Biaa		- 														//
// Spalinwka Czerwona	- 														//
// Parowz Czerwony		- 														//
// Tramwaj				- 														//
//------------------------------------------------------------------------------//
#define defCV1		3
#define CV1_Mask	0x7F					// Adres 0..127


//------------------------------------------------------------------------------//
//CV2 - Minimalne napicie na silniku (0 - 50%)							0..127	//
//------------------------------------------------------------------------------//
#define defCV2	30
#define CV2_Mask	0x7F					// Min napiecie 0..127


//------------------------------------------------------------------------------//
//CV3 - Czas rozpdziania												0..31	//
// CV3 * 8ms * liczba krokw / 8												//
// np: CV3=15 daje max czas rozpedziania: 0.008s * 15 * 255/8 = 3 sekund		//
// Wpisanie 0 wycza funkcj													//
//------------------------------------------------------------------------------//
#define defCV3  10
#define CV3_Mask	0x1F					// Czas Rozpedziania


//------------------------------------------------------------------------------//
//CV4 - Czas hamowania (reguy jak dla rozpedziania)					0.15	//
//------------------------------------------------------------------------------//
#define defCV4  3
#define CV4_Mask	0x0F					// Czas Hamowania


//------------------------------------------------------------------------------//
//CV5 - Maksymalne napicie na silniku (50 - 100%)						127..255//
//------------------------------------------------------------------------------//
#define defCV5	255
#define CV5_Mask	0x80					// Max napicie 128...255


//------------------------------------------------------------------------------//
//CV7 - ID wersja dekodera														//
//------------------------------------------------------------------------------//
unsigned char CV7_IdVesrion CODE = DccVersion;


//------------------------------------------------------------------------------//
//CV8 - ID producenta - Wpisanie 8 przywraca ustawienia fabryczne				//
//------------------------------------------------------------------------------//
unsigned char CV8_IdProd CODE = 0x0d;


//------------------------------------------------------------------------------//
//CV9 - Czstotliwoc PWM'a												0..3	//
// 0 - 250Hz																	//
// 1 - 500Hz																	//
// 2 - 1kHz																		//
// 3 - 2kHz																		//
//------------------------------------------------------------------------------//
#define defCV9		1
#define CV9_Mask	0x03					// Czstotliwoc PWM'a 0..3


//------------------------------------------------------------------------------//
//CV11 - Czas w 8ms od braku transmisji do wyczenia silnika			0..255	//
//  lub przejscia na jazd analogow											//
//  np: CV11 = 127 da czas TimeOut 0.008s * 127 = 1 sekunda						//
// To czy silnik sie zatrzyma, czy bedzie jazda analogowa zaley od CV29		//
//------------------------------------------------------------------------------//
#define defCV11		100/DivTim
#define CV11_Mask	0xFF					// Czas pejcia na jazd analog lub zatrzymanie lokomotywy


//------------------------------------------------------------------------------//
//CV27 - Decoder Automatic Stopping Configuration
// (+1) Bit0 = "1" Zatrzymanie gdy odchyka dodatnia i jedzie do przodu
// (+2) Bit1 = "1" Zatrzymanie gdy odchyka ujemna i jedzie do tyu
// (+4) Bit2 = "1" zmienia reakcj na kierunek
//------------------------------------------------------------------------------//
#define defCV27				2+1
#define CV27_R				0		// (+1)
#define CV27_L				1		// (+2)
#define CV27_Revers			2		// (+4)


//------------------------------------------------------------------------------//
//CV29 - Konfiguracja dekodera													//
//  (+1) Bit0 = "0" - DIR normal, "1" - DIR reversed (zamienione kierunki jazdy)
//  (+2) Bit1 = "0" 14 krokw, "1" - 28 krokw
//  (+4) Bit2 = "0" tylko DCC (brak transmisji to stop), "1" - Analog moliwy (gdy brak transmisji)
//		 Bit3 = "0" dekoder tylko odbiera rozkazy, "1" = Power Source Conversion Enabled, See CV#12 for more information,
//  	 Bit4 = "0" prdko kontrolowana przez CV2,5,6, "1" indywidualna tablica prdkoci (CV66..CV95)
//		 Bit5 = "0" adres jednobajtowy, =1 adres rozszeony
//Bit 6 = Reserved for future use.
//Bit 7 = Accessory Decoder: "0" = Multifunction Decoder, "1" = Accessory Decoder (see CV #541 for a description of assignments for bits 0-6)
//------------------------------------------------------------------------------//
#define defCV29				2
#define CV29_Dir			0		// (+1)
#define CV29_Step			1		// (+2)
#define CV29_Analog			2		// (+4)


//------------------------------------------------------------------------------//
//Rejestry konfigurujce wyjcia funkcyjne:
//
//CV60_Out0cfg
//CV61_Out1cfg
//CV62_Out2cfg
//CV63_Out3cfg
//CV64_Out4cfg
//Funkcje bitw:   Bit7  Bit6  Bit5  Bit4  Bit3  Bit2  Bit1  Bit0
//					-     -     -    F0    F4    F3    F2    F1
//Przykad:	CV60 = 00010000 wyjcie 0 kontrolowane funkcj F0 (Light)
//			CV61 = 00010001 wyjcie 1 kontrolowane funkcj F0 i F1.
//			CV62 = 1XXXXXXX wyjcie 2 cay czas wczone
//
//CV70_Out0effect
//CV71_Out1effect
//CV72_Out2effect
//CV73_Out3effect
//CV74_Out4effect
//Funkcje bitw:	Bit7  Bit6  Bit5  Bit4  Bit3  Bit2  Bit1  Bit0
//					1/2   1/4A  1/4B  MARs  Strb  Dim   Rev   Fwd
//
//Przykad:	CV70 = 01000000 is .25sec On/.25sec Off (Phase A).
//			CV71 = 00100000 is .25sec Off/.25sec On (Phase B). - wyjcia 0 i 1 migaj naprzemiennie
//			CV72 = 00001000 produces a strobe light effect.
//			CV73 = 00000000 is simple On/Off switch effect.
//			Na w/w rejestrach mona stosowac funkcje AND..
//			CV74 = 00011000 is MARs effect in Forward direction only.
//Ustawienie wyj F0 i F1 do sterowania oswietleniem zalenie od kierunku jazdy:
//			CV60 = 16 (ustawienie domylne)
//			CV61 = 16
//			CV70 = 2
//			CV71 = 1
//------------------------------------------------------------------------------//
#define CVfx_F1				0
#define CVfx_F2				1
#define CVfx_F3				2
#define CVfx_F4				3
#define CVfx_F0				4

#define defCV60				(1<<CVfx_F0) | (1<<CVfx_F1)
#define defCV61				(1<<CVfx_F0) | (1<<CVfx_F1)
#define defCV62				2
#define defCV63				4
#define defCV64				8

//					1/2   1/4A  1/4B  MARs  Strb  Dim   Rev   Fwd
#define CVeffect_1_2		7
#define CVeffect_1_4A		6
#define CVeffect_1_4B		5
#define CVeffect_MARs		4
#define CVeffect_Strb		3
#define CVeffect_Dim		2
#define CVeffect_Rev		1
#define CVeffect_Fwd		0

#define defCV80				(1<<CVeffect_Fwd)
#define defCV81				(1<<CVeffect_Rev)
#define defCV82				0
#define defCV83				0
#define defCV84				0



//CV134 - poziom sygnau po ktrym nastapi zatrzymanie lokomotywy przy asymetrii na szynach
#define	defCV134	6
#define CV134_Mask	0x1F					// Maska poziomu wyzwalania ABC



//CV136 - prdkoc do ktrej zwolni lokomotywa, jeli ustawione zwalnianie zamiast zatrzymania po wykryciu asymetrii
#define	defCV136	128
#define CV136_Mask	0xFF


//-------------------------- Definicje IO dla rnych typw CPU  ------------------------------//
#if DccVersion == 10
	#define RailR	( PINB & (1 << (PB2) ) )		// Sygna z szyny lewej (do odczytu) IMPULSW I AC
	#define RailL	( PINB & (1 << (PB1) ) )		// Sygna z szyny prawej (do odczytu) AC
	#define Dir		PB3								// Sterowanie kierunkiem
	#define F0		PB0								// Sterowanie oswietleniem
	#define defDDRB 0x19							// PB0, PB3 i PB4 wyjsciami
	#define	defPORTB 0x00							// Podciaganie wyczone
	#define VERSION OK								// Znacznik poprawnej deklaracji softu
	#if (_AVR_IOTN85_H_ != 1)						// Sprawdzenie poprawnoci typu CPU
		#error "ZLY TYP PROCESORA"
	#endif
#endif


#if DccVersion == 11
	#define RailR	( PINB & (1 << (PB2) ) )		// Sygna z szyny lewej (do odczytu) IMPULSW I AC
	#define RailL	( PINB & (1 << (PB3) ) )		// Sygna z szyny prawej (do odczytu) AC
	#define Dir		PB1								// Sterowanie kierunkiem
	#define F0		PB0								// Sterowanie oswietleniem
	#define defDDRB 0x13							// PB0, PB3 i PB4 wyjsciami
	#define	defPORTB 0x00							// Podciaganie wyczone
	#define VERSION OK								// Znacznik poprawnej deklaracji softu
	#if (_AVR_IOTN85_H_ != 1)						// Sprawdzenie poprawnoci typu CPU
		#error "ZLY TYP PROCESORA"
	#endif
#endif


//---------- Deklaracja wymaganych pinw -----------
#if DccVersion <= 11
	#define SetDir  PORTB |=  (1 << (Dir) )			// Ustaw wyjscie kierunku
	#define ClrDir	PORTB &= ~(1 << (Dir) )			// Kasuj wyjscie kierunku
	#define InDir	( PORTB & (1 << (Dir) )	)		// Odczyt wyjcia DIR
	#define SetF0	PORTB |=  (1 << (F0) )			// Ustaw wyjcie oswietlenia F0
	#define ClrF0	PORTB &= ~(1 << (F0) )			// Wycz wyjcie oswietlenia F0
	#define EorF0	PORTB ^=  (1 << (F0) )			// Przecz wyjcie oswietlenia F0
#endif


#if Accesory == 1
	#define	Serwice	( PINB & (1 << (PB2) ) )
#endif


//-------------------------- Alerty  ------------------------------//
#ifndef F_CPU
	#error "Nie zdefiniowany zegar procesora"
#endif

#ifndef VERSION										// Sprawdzenie czy poprawnie zadeklarowano wersje softu
	#error "WYBRANO ZLA WERSJE SOFTU"
#endif


CODE char Nversja[] = "Versja: ";
CODE char versja = DccVersion;						// Wersja programu
CODE char compilied[] = "Skompilowano: ";
CODE char dzien[] = __DATE__;						// Data kompilacji
CODE char czas[] = __TIME__;						// Czas kompilacji


//-------------------------- Zmienne, Funkcje  ------------------------------//
				//--- CV ---
unsigned char CV1_adr		= defCV1;		// CV1 - adres lokomotywy
unsigned char CV2_MinV		= defCV2;		// CV2 - min napiecie
unsigned char CV3_rozped	= defCV3;		// CV3 - czas rozpedzania
unsigned char CV4_hamow		= defCV4;		// CV4 - czas hamowania
unsigned char CV5_MaxV		= defCV5;		// CV5 - max napicie
unsigned char CV9_Fpwm		= defCV9;		// CV9 - Czestotliwo PWM'a
unsigned char CV11_OverTime	= defCV11;		// CV11 czas w 8ms od braku transmisji do wyczenia silnika lub przejscia na jazd analogow
unsigned char CV27_ABC		= defCV27;
unsigned char CV29_Cfg		= defCV29;		// CV29 konfiguracja,
unsigned char CV134_ABC		= defCV134;
unsigned char CV136_ABC		= defCV136;


				//--- NoInit ---
unsigned int  PowerOn NOINIT;				// Cig do sprawdzenia
unsigned char MemSpeed NOINIT;
unsigned char MemAspeed NOINIT;
unsigned char MemKomenda NOINIT;

				//--- Tabela predkoci ---
				// 					    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
unsigned char TabSpeed28[32]	CODE = {0, 78, 84, 90, 96,102,108,115,121,127,133,139,145,151,157,164,170,176,182,188,194,200,206,212,219,225,231,237,243,244,249,255};

void SetLight(unsigned char komenda);
void SetFx(unsigned char nr,unsigned char funkcja);
void SetPower32(unsigned char komenda);
void SetPWM();
void SetTCCR1(unsigned char wartosc);
void SetPower128(unsigned char komenda);
void SetDirP();
void SetDirN();
void Hamuj();
void Stop();
void SpeedMax();
void KorektaCV4();

void irq();
void BrakTransmisji();
void SystemInit();
void SetCv(unsigned char adres, unsigned char komenda);
void PgmMode(unsigned char adres, unsigned char komenda);
void Treset();

unsigned char analiza_bitu(unsigned int czas_imp);
void analiza_danych(unsigned char bit);
unsigned int volatile tmpIMP=0;
enum {ST_WAItmpIMP,ST_POMIMP_H,ST_POMIMP_L,ST_WAITSYNC,ST_WAITDATA0,ST_WAITDATA1,ST_WAITDATA2};
unsigned char volatile stanBit=ST_WAItmpIMP,stanData=ST_WAITSYNC;
unsigned char volatile TimeOutTrans=0,TimeOutRst=0,Utimer=0,SpdTimer=0;
unsigned char volatile BlkSpeed=0,Div8ms=1;
unsigned char volatile adresTMP,komendaTMP,dana1TMP=0,dana2TMP=0,crcTMP,crc,FL_Complete=0;
unsigned char volatile Speed=0,Aspeed=0,CV4_Korrect=0,Kierunek=0;
unsigned char volatile GrupaF0_F4=0,GrupaF5_F8=0,GrupaF9_F12=0;
unsigned char adres,komenda,dana1,dana2;
unsigned char cnt_bit_sync=0,cnt_bit_data=0;
void execute_command(unsigned char adres,unsigned char komenda);
#define ElemVolt	8					// Liczba elementw tablicy uredniania napicia na szynach
#define RolVolt		3					// Liczba przesuni przy obliczaniu redniej (4 dla ElemVolt, 3 dla ElemVolt 8)
#define MaskVolt	0xE000				// Maska dla wartoci ujemnych (0xF000 dla RolVolt 4, 0xE000 dla RolVolt 3)
char volatile VoltTab[ ElemVolt ];		// Tablica na wynik przetwarzania AC
int volatile VoltSred=0,VoltOdch=12;	// rednia napicia i rednie dopuszczalne odchylenie
unsigned char FL_TabVolCompil=0;		// Informacja o zapenionej tablicy napi



//--- Struktura w EEprom ---
//unsigned char EEcfg EEMEM = 3;			//??? Zapamietanie w eeprom wartoci 5
struct
{
char CV1_adr,		// CV1 - adres lokomotywy
	 CV2_MinV,		// CV2 - min napiecie
	 CV3_rozped,	// CV3 - czas rozpedzania
	 CV4_hamow,		// CV4 - czas hamowania
	 CV5_MaxV,		// CV5 - max napicie
	 CV9_Fpwm,		// CV9 - czstotliwoc PWM'a
	 CV11_OverTime,	// CV11 czas w 8ms od braku transmisji do wyczenia silnika lub przejscia na jazd analogow
	 CV27_ABC,
	 CV29_Cfg,		// CV29 konfiguracja,
	 CV134_ABC,
	 CV136_ABC,
	 CV60_71[12],	// Konfiguracja wyj F0..F12
	 CV80_91[12],	// Efekty wyj F0..F12
	 CV100_132[32];	// Indywidualna tablica predkoci
}eeprom EEMEM =
{
	defCV1,			// CV1 - adres lokomotywy
	defCV2,			// CV2 - min napiecie
	defCV3,			// CV3 - czas rozpedzania
	defCV4,			// CV4 - czas hamowania
	defCV5,			// CV5 - max napicie
	defCV9,			// CV9 - czstotliwoc PWM'a
	defCV11,		// CV11 czas w 8ms od braku transmisji do wyczenia silnika lub przejscia na jazd analogow
	defCV27,
	defCV29,		// CV29 konfiguracja,
	defCV134,
	defCV136,
	{defCV60,defCV61,defCV62,defCV63,defCV64},
	{defCV80,defCV81,defCV82,defCV83,defCV84},
	{0, 78, 84, 90, 96,102,108,115,121,127,133,139,145,151,157,164,170,176,182,188,194,200,206,212,219,225,231,237,243,244,249,255}
};



//------------------------------------------------------------------//
//			Sekcja ".initX"	- ZERO (R1) zainicjalizowane)			//
//------------------------------------------------------------------//
unsigned char DnoStosu NOINIT;			// Kontrola stosu
void ClrIntRam(void) __attribute__ ((naked)) __attribute__ ((section (".init3")));
void ClrIntRam(void)
{
//unsigned int x;
unsigned char *AdrRam;
//	for (AdrRam=(unsigned char*)0x0200; AdrRam < (unsigned char*)RAMEND-32; AdrRam++)			// Wpisanie do IntRam $FF
//		{
//		*AdrRam = 0xFF;
//		}
	for (AdrRam=&DnoStosu; AdrRam < (unsigned char*)RAMEND-32; AdrRam++)			// Wpisanie do IntRam $FF
		{
		*AdrRam = 0xFF;
		}
}



//**********************************************************************//
//						Program gwny			 						//
//**********************************************************************//
int main()
{
	//--- Init Timer 0 ---
	TCCR0B = ( 0x2 );							// Preskaler na 8 (8.000.000Hz / 8 ) = 1us
	TIMSK |= ( 1<<TOIE1 );						// Zezwolenie na IRQ od przepelnienia timera 1
	MCUCR = ( 1<<ISC00 );						// Kazde zbocze na INT0 wywouje IRQ
	GIMSK |= ( 1<<INT0 );						// Zezwolenie na IRQ od wejcia PB2


	//--- Init Timer 1 ---
	GTCCR = (1<<PWM1B) | (1<<COM1B1);			// Wczenie PWM'a
	OCR1C = 255;								// Max warto do ktrej liczy PWM
	SetTCCR1( defCV9 );							// Czstotliwoc pracy PWM'a


	//--- Init PIO ---	// Nie kuglowa MCUCR (dla ATtiny85) bo zbocza dla INT0 sie skaszania
	DDRB = defDDRB;								// PB0, PB3 i PB4 wyjsciami
	PORTB =defPORTB;							// Podciaganie wyczone


	//--- Init peryferii, odczyt eeprom ---
	SystemInit();								// Init systemu
	ClrF0;										// Wczenie oswietlenia


	//--- init WDG ---
	//WDTO_15MS
	//WDTO_30MS
	//WDTO_60MS
	//WDTO_120MS
	//WDTO_250MS
	//WDTO_500MS
	//WDTO_1S
	//WDTO_2S
	wdt_enable( WDTO_120MS);					// Blokuje IRQ !!!


	//--- Przywrcenie ustawie z kopi w RAM jesli reset jej nie zniszczy ---
	if (PowerOn == 0xDC11)						// Okreslenie przyczyny resetu (krtka przerwa / WDG czy dusza)
	{
		SetPower32(MemKomenda);					// Krtka przerwa wiec przywrcenie ostatniej komendy
		Aspeed = MemAspeed;						// i odtworzenie predkoci
		Speed  = MemSpeed;
	}
	PowerOn = 0xDC11;							// Zapamitanie znakw kontrolnych


//	if ( (MCUSR & (1<<WDRF))!= 0) {MCUSR |= 1<<WDRF; }		// ??? Przyczyna resetu WDG
//	if ( (MCUSR & (1<<BORF))!= 0) {MCUSR |= 1<<BORF; }		// ??? Przyczyna resetu Spadek napiecia zsilajacego
//	if ( (MCUSR & (1<<EXTRF))!= 0) {MCUSR |= 1<<EXTRF; }	// ??? Przyczyna resetu Wyprowadzenie reset
//	if ( (MCUSR & (1<<PORF))!= 0) {MCUSR |= 1<<PORF; }		// ??? Przyczyna resetu Wczenie zasilania
//??? tylko ATMega z JTAG	if ( (MCUSR & (1<<JTRF))!= 0) {MCUSR |= 1<<JTRF; }		// ??? Przyczyna resetu JTAG


	//--- Init IRQ ---
	sei();
	ADCSRA = (1<<ADIF) | (1<<ADEN) | (1<<ADSC);	// Init konwersji AC
	ADMUX =  1;									// Mux na wejscie PB3



	//--------------------------------------------------------------//
	//			Ptla gwna										//
	//--------------------------------------------------------------//
	while(1)
	{
		wdt_reset();

		//--- Jeli odebrana kompletna ramka z poprawn CRC ---
		if ( FL_Complete == 1 )
		{
			execute_command(adres,komenda);			// Wykonanie komendy
			FL_Complete = 0;						// Info o wykonaniu komendy

			//--- Obsuga F0..F12 --
			if ( (GrupaF0_F4 & 0x01) != 0 ){SetFx(1,1);}else{SetFx(1,0);}
			if ( (GrupaF0_F4 & 0x02) != 0 ){SetFx(2,1);}else{SetFx(2,0);}
			if ( (GrupaF0_F4 & 0x04) != 0 ){SetFx(3,1);}else{SetFx(3,0);}
			if ( (GrupaF0_F4 & 0x08) != 0 ){SetFx(4,1);}else{SetFx(4,0);}
			if ( (CV29_Cfg & (1<<CV29_Step) ) != 0 )			// Jeli tryb 28 krokw to steruj owietleniem z komendy
				{
				if ( (GrupaF0_F4 & 0x10) != 0 ){SetFx(0,1);}else{SetFx(0,0);}
				}



/*
			if ( (GrupaF5_F8 & 0x10) != 0 ){SetFx(5,1);}else{SetFx(5,0);}
			if ( (GrupaF5_F8 & 0x11) != 0 ){SetFx(6,1);}else{SetFx(6,0);}
			if ( (GrupaF5_F8 & 0x12) != 0 ){SetFx(7,1);}else{SetFx(7,0);}
			if ( (GrupaF5_F8 & 0x14) != 0 ){SetFx(8,1);}else{SetFx(8,0);}
			if ( (GrupaF9_F12 & 0x00) != 0 ){SetFx(9,1);}else{SetFx(9,0);}
			if ( (GrupaF9_F12 & 0x01) != 0 ){SetFx(10,1);}else{SetFx(10,0);}
			if ( (GrupaF9_F12 & 0x02) != 0 ){SetFx(11,1);}else{SetFx(11,0);}
			if ( (GrupaF9_F12 & 0x04) != 0 ){SetFx(12,1);}else{SetFx(12,0);}
*/
		}


		//--- Jesli brak transmisji ---
		if ( TimeOutTrans == 0 )
		{
			BrakTransmisji();
		}


	}


//--- koniec programu gwnego ---//
return(0);
}



//***********************************************************************//
//*							PODPROGRAMY									*//
//***********************************************************************//



//----------------------------------------------------------------------//
//					Ustawienie czstotliwoci PWM'a						//
//----------------------------------------------------------------------//
void SetTCCR1(unsigned char wartosc)
{


	switch( wartosc )
		{
		case 0: TCCR1 = 0x08;								// Preskaler na 512 (250Hz)
		break;
		case 1: TCCR1 = 0x07;								// Preskaler na 256 (500Hz)		OK
		break;
		case 2: TCCR1 = 0x06;								// Preskaler na 128 (1kHz)		Piszczy
		break;
		case 3: TCCR1 = 0x05;								// Preskaler na 64 (2kHz)
		break;
		default: TCCR1 = 0x07;								// Warto domylana
		}


//	TCCR1 = 0x09;								// Preskaler na 1024 (127Hz)	Brzczy
//	TCCR1 = 0x02;								// Preskaler na 8 (15kHz)		Za ostro
}



//----------------------------------------------------------------------//
//					Obsuga IRQ od wejcia INT 0						//
//----------------------------------------------------------------------//
ISR( INT0_vect )
{
static unsigned char volatile VoltR=0,VoltL=0;
static char PozVolt=ElemVolt-1;
unsigned char nic;

#define MIN_HIGH   52
#define MAX_HIGH   64
#define MIN_LOW    90
#define MAX_LOW  150	//??? 9999

	if ( RailR == 0)										// Mierzymy czas poziomu (R / L - zaley od szyny)
		{
//EorF0; //??? OSCYLOSKOP
		// Odczytujemy timer
		if ( (TCNT0 > MIN_HIGH) && (TCNT0 < MAX_HIGH) )
			{
			analiza_danych(1);
			}
		else if ( (TCNT0 > MIN_LOW) && (TCNT0 < MAX_LOW) )
			{
			analiza_danych(0);								// Skadamy ramk
			}
		else if (TCNT0 > MAX_LOW)
			{												// Jeli czas impulsu wikszy ni czas max 
			TCNT0 = 0;										// zerujemy timer
			return;											//  i wychodzimy bez uruchamiania konwersji AC
			}
		else
			{
			return;											// Jeli czas poza zakresem to wychodzimy z przerwania
			}												//  nie zerujc timera i nie startujc AC


		#ifndef NtstADIF
		if ( (ADCSRA & (1<<ADIF) ) != 0 )					// Jesli przetwarzanie zakoczone to odczyt wyniku
			{
		#endif
			VoltR = ADCL;// Wynik do zmiennej
			nic = ADCH;										// ADLAR=0 wic konieczne jest dodatkowe odczytanie ADCH
			ADMUX = 3;										// Mux na wejscie PB3 (dla V1.1 i ADLAR = 0)
			ADCSRA = (1<<ADIF) | (1<<ADEN) | (1<<ADSC) | 4;	// Start konwersji z podzielnikiem 16
		#ifndef NtstADIF
				}
		#endif
//EorF0; //??? OSCYLOSKOP
		}
	else
		{
//EorF0; //??? OSCYLOSKOP
		TCNT0 = 0;											// Zerujemy timer
		#ifndef NtstADIF

		if ( (ADCSRA & (1<<ADIF) ) != 0 )					// Jesli przetwarzanie zakoczone to odczyt wyniku
			{
		#endif
			VoltL = ADCL;									// Wynik do zmiennej
			nic = ADCH;										// ADLAR=0 wic konieczne jest dodatkowe odczytanie ADCH
			ADMUX =  1;										// Mux na wejscie PB2 (dla V1.1 dla ADLAR = 0
			ADCSRA = (1<<ADIF) | (1<<ADEN) | (1<<ADSC) | 4;	// Start konwersji z podzielnikiem 16

			//--- Obliczenie rnicy napi na szynach ---
			VoltTab[ PozVolt-- ] = VoltR - VoltL;			// Obliczenie rnicy napi i zapisanie w tablicy
			if ( PozVolt == -1 )							// Jeli tablica pena to obliczenie redniej
				{
				PozVolt = ElemVolt-1;						// Wskanik koca tablicy
				FL_TabVolCompil = 1;						// Informacja o zapenieniu tablicy
				}
//EorF0; //??? OSCYLOSKOP
		#ifndef NtstADIF
			}
		#endif

	}


}



//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 1	(PWM)						//
//																		//
// przy preskalerze na 1024 (127Hz) przerwanie co ok 8ms				//
// przy preskalerze na 8 (15kHz) przerwanie co ok 64us					//
//----------------------------------------------------------------------//
ISR( TIM1_OVF_vect )
{
	//--- Zmiana stanu linii DIR synchronicznie w IRQ ---
	if ( Kierunek == 0) { SetDir; }				// Dir = H
	if ( Kierunek == 1){ ClrDir; }				// Dir = L
	//--- Zalenie od kierunku do PWM wpisujemy warto zanegowana lub nie
	if ( InDir == 0)
		{	//--- Kierunek naprzd ---
		OCR1B = Aspeed;
		}
	else
		{	//--- Kierunek wstecz ---
		OCR1B = 255 - Aspeed;
		}


	//--- Obsuga podzielnika ---
	if ( (TCCR1 & 0x0F) == 0x09)				// Jesli 125Hz nie dziel zegara
	{
		irq();
	}
	else if ( (TCCR1 & 0x0F) == 0x08)			// Jesli 250Hz to dziel zegar na 2
	{
		if (++Div8ms >= 2)//??? zrobi Div8sm-- != 0
		{
			Div8ms=0;		//??? zrobi Div8sm=2 (w innych 4, 8, 16, 128
			irq();
		}
	}
	else if ( (TCCR1 & 0x0F) == 0x07)			// Jesli 500Hz to dziel zegar na 4
	{
		if (++Div8ms >= 4)
		{
			Div8ms=0;
			irq();
		}
	}
	else if ( (TCCR1 & 0x0F) == 0x06)			// Jesli 1kHz to dziel zegar na 8
	{
		if (++Div8ms >= 8)
		{
			Div8ms=0;
			irq();
		}
	}
	else if ( (TCCR1 & 0x0F) == 0x05)			// Jesli 2kHz to dziel zegar na 16
	{
		if (++Div8ms >= 16)
		{
			Div8ms=0;
			irq();
		}
	}
	else if ( (TCCR1 & 0x0F) == 0x02)			// Jesli 15 khz to dziel zegar na 128
	{
		if (++Div8ms >= 128)
		{
			Div8ms=0;
			irq();
		}
	}


}



//----------------------------------------------------------------------//
// Procedura wykonywana co 8 ms
//----------------------------------------------------------------------//
void irq()
{
	if ( TimeOutTrans != 0 ) TimeOutTrans--;	// Zminiejszamy timer az osiagnie zero
	if ( TimeOutRst   != 0 ) TimeOutRst--;		// Zminiejszamy timer az osiagnie zero
	if ( SpdTimer     != 0 ) SpdTimer--;		// Zminiejszamy timer az osiagnie zero
	if ( Utimer       != 0 ) Utimer--;			// Zminiejszamy timer az osiagnie zero

	SetPWM();
}



//----------------------------------------------------------------------//
// Procedura wykonywana co 8 ms
//----------------------------------------------------------------------//
void SetPWM()
{
#define  krok_na_okres 8

// Aspeed - aktualna predkoc obrotowa silnika
// Speed  - zadana predko obrotowa
// MemSpeed - prdko od ostatniej zmiany (do okrelenia czy przyspieszamy czy zwalniamy)

//??? Jesli w trakcie przyspieszania (gdy jeszcze nie osiagnieto zadanej predkosci)
// zaczniemy zmniejszac predkosc, to przestaje ona rosnac ale nie dochodzi do zaprogramowanego poziomu
// wyslanie kolejnej komendy zmniejszenia predkosc przywraca wszystko do normy


//if ( (CV3_rozped == 0) && (Przyspieszenie < 0) ) 	// Jeli CFG = 0 to nie obsugujemy powolnego przyspieszania
//	{
//	Aspeed = Speed;
//	MemSpeed = Speed;
//	}
//	if ( CV3_rozped == 0 ) { CV3_rozped=1; }		// Jeli CFG = 0 to nie obsugujemy powolnego przyspieszania (dajemy min)

//if ( (CV4_hamow == 0) && (Przyspieszenie > 0) ) 	// Jeli CFG = 0 to nie obsugujemy powolnego hamowania
//	{
//	Aspeed = Speed;
//	MemSpeed = Speed;
//	}
//
//	if ( CV4_hamow == 0 ) { CV4_hamow=1; }			// Jeli CFG = 0 to nie obsugujemy powolnego hamowania (dajemy min)


	


	//--- Przyspieszanie ---
	if ( Aspeed < Speed  )								// Jeli jeszcze nie oiagnieto zadanej prdkoci
		{
		if ( SpdTimer == 0 )							// Jeli timer zakoczy odliczanie
			{											//  to ponownie wpisz mu warto
			SpdTimer = CV3_rozped;
			if ( (Speed != 0 ) && (Aspeed < CV2_MinV) )	// Jeli prdko ustawiona <> 0
				{
				Aspeed = CV2_MinV;						// to startuj od obratw okrelonych jako min
				}
			else if ( (Aspeed+krok_na_okres ) < Speed )	// jeli Aspeed przekroczyo by Speed to wpisz Speed
				{
				Aspeed += krok_na_okres;
				}
			else
				{
				Aspeed = Speed;
				}
			}
		}
	//--- Zwalnianie ---
	else if ( Aspeed > Speed  )						// Jeli jeszcze nie oiagnieto zadanej prdkoci
		{
		if ( SpdTimer == 0 )						// Jeli timer zakoczy odliczanie
			{										// To ponownie wpisz mu warto
			SpdTimer = CV4_hamow;
			if ( (Aspeed-krok_na_okres) > Speed )	// To ja zmniejsz, jesli miao by byc mniej niz 0 to wpisz 9
				{
				Aspeed -= krok_na_okres;
				}
			else
				{
				Aspeed = Speed;
				}
			}
		}

//Aspeed = Speed;//???? Tryb bez przyspiesznia i zwalniania

}



//----------------------------------------------------------------------//
// Analizuje warto bitu na podstawie czasu trwania impulsu
//----------------------------------------------------------------------//
unsigned char analiza_bitu(unsigned int czas_imp)
{
//#define MIN_HIGH   52/10
//#define MAX_HIGH   64/10
//#define MIN_LOW    90/10
//#define MAX_LOW  9999/10

	if ( (czas_imp >= 4) && (czas_imp <= 7) )
		{
		return(1);
		}
	else if ( (czas_imp >= 8)  && (czas_imp <= 1000) )
		{
		return(0);
		}
	else
		{
		return(2);			// Poza zakresem
		}
}



//----------------------------------------------------------------------//
// Odczytuje kolejne dane ramki i wykonuje rozkaz
//----------------------------------------------------------------------//
void analiza_danych(unsigned char bit)
{

	//--- Wykrywanie synchronizacji ---
	if ( (bit==0) && (cnt_bit_sync >= 10) )		// jeli conajmniej 10 jedynek przed zerem
		{
		cnt_bit_sync = 0;						// zeruj licznik bitw synchronizacji
		cnt_bit_data = 0;						// zeruj licznik bitw danych
		stanData = ST_WAITDATA0;				// Zmie stan


		}
	if (bit==0) {cnt_bit_sync=0; }				// jeli bit zero to zeruj licznik jedynek (synchronizacji)
	if (bit==1) {cnt_bit_sync++; }				// jesli jeden to zwiekszaj licznik jedynek (synchronizacji)
		{
		if (cnt_bit_sync >=9 ){stanData = ST_WAITSYNC; }	// Jeli 9 lub wiecej jedynek to synchro
		}


	//--- Odbior ramki ---
	switch(stanData)
		{
		case(ST_WAITDATA0):					///--- oczekiwanie na kompletny bajt nr 0 (adres)
			if (bit==0)									// Odebrano zero
				{
				adresTMP <<= 1;
				}
			if (bit==1)									// Odebrano jeden
				{
				adresTMP <<= 1;
				adresTMP |= 1;
				}
			if (cnt_bit_data++ == 8)					// Jeli odebrano 8 bitw
				{
				crc = adresTMP;							// Liczymy CRC
				cnt_bit_data = 0;						// zeruj licznik bitw
				stanData = ST_WAITDATA1;				// Zmie stan
				}
		break;
		case(ST_WAITDATA1):					///--- oczekiwanie na kompletny bajt nr 1 (komenda)
			if (bit==0)									// Odebrano zero
				{
				komendaTMP <<= 1;
				}
			if (bit==1)									// Odebrano jeden
				{
				komendaTMP <<= 1;
				komendaTMP |= 1;
				}
			if (cnt_bit_data++ == 8)					// Jeli odebrano 8 bitw (bit startu pakietu zlewamy)
				{
				crc ^= komendaTMP;						// Liczymy CRC
				cnt_bit_data = 0;						// zeruj licznik bitw
				stanData = ST_WAITDATA2;				// Zmie stan
				}
		break;

		case(ST_WAITDATA2):					///--- oczekiwanie na kompletny bajt nr 2 (dana)
			if (bit==0)									// Odebrano zero
				{
				crcTMP <<= 1;
				}
			if (bit==1)									// Odebrano jeden
				{
				crcTMP <<= 1;
				crcTMP |= 1;
				}
			if (cnt_bit_data++ == 8)					// Jeli odebrano 8 bitw (bit startu pakietu zlewamy)
				{
				cnt_bit_data = 0;						// zeruj licznik bitw
				stanData = ST_WAITSYNC;					// Zmie stan
				//--- jesli crc zgodne to wykonujemy komed
				if (crcTMP == crc)
					{
					TimeOutTrans = CV11_OverTime;		// CRC ok wic ustawiamy timer
					if (FL_Complete == 0)				// Jeli poprzedni rozkaz wykonany to przepisz z TEMP do bufora
						{
						adres = adresTMP;
						komenda = komendaTMP;
						dana1 = dana1TMP;
						dana2 = dana2TMP;
						FL_Complete = 1;
						}
					}

				}
		break;
		}


}


//----------------------------------------------------------------------//
//					Brak komunikacji, stan awaryjny lub jazda analogowa	//
//----------------------------------------------------------------------//
void BrakTransmisji()
{
	if ( (CV29_Cfg & (1<<CV29_Analog)) != 0)	// Jeli jazda analogowa dozwolona
	{											// to wcz silnik na maxa
		if ( RailR == 0 )						// Jeli jedynka to jazda naprzd
		{
			SetDirP();							// Kierunek
			SpeedMax();							// Max prdko
			SetFx(0,1);							// Wcz wiata zgodnie z ustawianiami w CV29
		}
		else									// W przeciwnym wypadku wstecz
		{
			SetDirP();							// Kierunek
			SpeedMax();							// Max prdko
			SetFx(0,1);							// Wcz wiata zgodnie z ustawianiami w CV29
		}
	}
	else										// Jesli jazda analogowa zabroniona
	{											// to ztrzymaj lokomotywe
		Hamuj();
	}

}



//----------------------------------------------------------------------//
//					Ustawienie kierunku naprzod (dla trybu 14/28 krokw)//
//----------------------------------------------------------------------//
void SetDirP()
{
	if ( BlkSpeed != 0 ) return;						// Nie zmienaj kierunku jesli wczona blokada odbioru

	//??? jeli PWM nie skoczy

	Kierunek = 0;

//	SetDir;												// Dir = H
//	GTCCR = (1<<PWM1B) | (1<<COM1B1) | (1<<COM1B0);		// Tryb PWM, wyjscie proste, preskaler
// W ATtiny85 PWM cos nie dziaa gdy  ustawiony bit COM1B0
}



//----------------------------------------------------------------------//
//					Ustawienie kierunku wstecz (dla trybu 14/28 krokw)	//
//----------------------------------------------------------------------//
void SetDirN()
{
	if ( BlkSpeed != 0 ) return;						// Nie zmienaj kierunku jesli wczona blokada odbioru

	Kierunek = 1;

//		ClrDir;												// Dir = L
//	GTCCR = (1<<PWM1B) | (1<<COM1B1);					// Tryb PWM, wyjscie zanegowane preskaler
// W ATtiny85 PWM cos nie dziaa gdy  ustawiony bit COM1B0
}



//----------------------------------------------------------------------//
//					Ustawienie prdkoci (dla trybu 14/28 krokw)		//
//----------------------------------------------------------------------//
void SetPower32(unsigned char komenda)
{
unsigned char Tspeed,x;
//static char StanAsymetrii=0;


	if ( BlkSpeed != 0 )							// Jesli zablokowany odbior prdkoci
		{
		if ( Aspeed != 0 )
			{
			return;									// a prdko nie spada do 0, to wyjdz z procedury
			}
		else
			BlkSpeed = 0;							// Prdko 0 wic odblokuj odbir
		}

/*
	// Analizuj 3 najstarsze bity
	if ( (komenda & 0xE0) == 0x40 )		//--- %010 (jazda w ty) ---
		{
		SetDirP();						// Zmiana musi by po SetPower (zmiana musi byc blokowana)
		}
	else if ( (komenda & 0xE0) == 0x60 )//--- %011 (jazda w przd) ---
		{
		SetDirN();						// Zmiana musi by po SetPower (zmiana musi byc blokowana)
		}
*/





	if ( (CV29_Cfg & (1<<CV29_Step)) != 0)			//--- jesli PWM 28 krokw ---
		{
		if ( (komenda & 0x10) != 0 )				// Gdy bit 5 ustawiony
			{
			Tspeed = ( (komenda & 0x0F) << 1) + 1;
			}
		else										// Gdy bit 5 zzerowany
			{
			Tspeed = ( (komenda & 0x0F) << 1) + 0;
			}
		}
	else											//--- Jeli PWM 14 krokw ---
		{
		Tspeed = ((komenda & 0x0F) << 1);			// Zmodyfikuj do 32 pseudo krokw
		}



		// Obliczenie redniej napicia na szynach
		if ( FL_TabVolCompil == 1)
			{
			VoltSred = 0;
			for (x=0; x<ElemVolt-1; x++)
				{
				if ( abs(VoltTab[x]) < (VoltOdch*2) )	// Jeli odchya nie zbyt dua
					{
					VoltSred += VoltTab[ x ];			// Dodawaj do redniej
					}									// W przeciwnym wypadku nie zmienij sredniej
				}
			if ( VoltSred == 0 )						// rednia do zmiennej ( dzielenie na 16 = przeuniecie o 4)
				{										// Jeli zero to nie rb nic
				}
			else if ( VoltSred < 0 )
				{
				VoltSred = (VoltSred >> RolVolt) | MaskVolt;	// jesli ujemna to po przesunieciu ustawiamy nastarsze bity
				}
			else
				{
				VoltSred >>= RolVolt;				// jeli dodatnia to tylko przeswamy
				}
//__asm__ __volatile__( "nop" );		// UZYWANE PRZY BreakPoint
			FL_TabVolCompil=0;						// Informacja, e tablica odczytana
			}



		//--- Zatrzymywa gdy asymetria R i jedzie do przodu ---
		if ( (CV27_ABC & (1<<CV27_R)) && ( InDir == 0) && !(CV27_ABC & (1<<CV27_Revers)) )
			{
			if ( VoltSred >= (signed char)CV134_ABC )					// Jeli asymertia "Dodatnia" to stop
				{
	// if CV27 then Hamuj() ELSE if Speed > CV136 THEN Speed = CV136_ABC;
				Hamuj();
				return;
				}
			}
		//--- Zatrzymywa gdy asymetria L i jedzie do tyu ---
		if ( (CV27_ABC & (1<<CV27_L)) && ( InDir != 0) && !(CV27_ABC & (1<<CV27_Revers)) )
			{
			if ( VoltSred <= -(signed char)CV134_ABC )					// Jeli asymertia "Dodatnia" to stop
				{
	// if CV27 then Hamuj() ELSE if Speed > CV136 THEN Speed = CV136_ABC;
				Hamuj();
				return;
				}
			}
		//--- Zatrzymywa gdy asymetria R i jedzie do TYU ---
		if ( (CV27_ABC & (1<<CV27_R)) && ( InDir != 0) && (CV27_ABC & (1<<CV27_Revers)) )
			{
			if ( VoltSred >= (signed char)CV134_ABC )					// Jeli asymertia "Dodatnia" to stop
				{
	// if CV27 then Hamuj() ELSE if Speed > CV136 THEN Speed = CV136_ABC;
				Hamuj();
				return;
				}
			}
		//--- Zatrzymywa gdy asymetria L i jedzie do PRZODU ---
		if ( (CV27_ABC & (1<<CV27_L)) && ( InDir == 0) && (CV27_ABC & (1<<CV27_Revers)) )
			{
			if ( VoltSred <= -(signed char)CV134_ABC )					// Jeli asymertia "Dodatnia" to stop
				{
	// if CV27 then Hamuj() ELSE if Speed > CV136 THEN Speed = CV136_ABC;
				Hamuj();
				return;
				}
			}



	//--- Ustawienie PWM'a ---
	if ( (komenda & 0x0F) == 0)							// Jeli prdko 0
		{
		Speed = 0;										// dajemy prdko 0, bo obliczanie Speed moze dac uamki
		}
	else if ( (komenda & 0x0F) == 1)					// Jeli prdko 1 (czyli zatrzymanie awaryjne)
		{
		Speed = 0; Aspeed=0;
		}
	else
		{
		//--- Czy zmieniono kierunek ? ---
		if ( (komenda & 0x20) != (MemKomenda & 0x20) )
			{
			BlkSpeed = 1;								// Blokuj odbior do czasu wychamowania lokomotywy
			Hamuj();									// Wcz Hamowanie
			}
		else
			{
			//Speed = pgm_read_byte( &TabSpeed28[ Tspeed ] );										// Tablica z Flash
			//Speed = eeprom.CV69_94[ Tspeed ];														// Tablica uytkownika z EEprom
			//           Zakres                     / Krokw *   Speed       + Ofset		(Monoymy i dzielymy przez 128 aby unikn operacji zmiennoprzecinkowych)
			//Speed = ( ( (CV5_MaxV - CV2_MinV) * 128) / 32 * Tspeed ) / 128 + CV2_MinV;
			Speed = ( ( ( (CV5_MaxV - CV2_MinV) << 7) / 32 * Tspeed ) >> 7) + CV2_MinV;
			}
		}





	MemKomenda = komenda;								// Zapamietanie ostatniej komendy
	MemSpeed   = Speed;									// i prdkoci
	MemAspeed  = Aspeed;

}



//----------------------------------------------------------------------//
//					Ustawienie prdkoci (dla trybu 128 krokw)			//
//----------------------------------------------------------------------//
void SetPower128(unsigned char Tspeed)
{
unsigned char Speed;

	// Wybor kierunku
	if ( (Tspeed & 0x80) != 0 )
		{
		SetDirP();
		}
	else
		{
		SetDirN();
		}

	Tspeed |= 0x7F;

	//           Zakres                     / Krokw *   Speed       + Ofset		(Monoymy i dzielymy przez 128 aby unikn operacji zmiennoprzecinkowych)
	Speed = ( ( ( (CV5_MaxV - CV2_MinV) << 7) / 128 * Tspeed ) >> 7) + CV2_MinV;

//---	Speed = ( CV5_MaxV - CV2_MinV ) / 255.0 * ((komenda & 0x7F)*128) + CV2_MinV; 	// Dziaa ale poera 4kB


	//--- Zalenie od kierunku do PWM wpisujemy warto zanegowana lub nie
	if ( InDir == 0)
		{	//--- Kierunek naprzd ---
		OCR1B = Speed;
		}
	else
		{	//--- Kierunek wstecz ---
		OCR1B = 255 - Speed;
		}


	MemKomenda = komenda;							// Zapamietanie ostatniej komendy
	MemSpeed   = Speed;								// i prdkoci
	MemAspeed  = Aspeed;


}




//----------------------------------------------------------------------//
//					Wczenie oswietlenia 								//
//----------------------------------------------------------------------//
void SetLight(unsigned char komenda)
{
	if ( (CV29_Cfg & (1<<CV29_Step) ) == 0 )		// Jeli 14 krokw to steruj oswietleniem z komendy prkoci
	{												// Dla trybu 28 krokw sterowanie oswietleniem realizowane jest osobna komed
		if ( (komenda & 0x10) != 0 )
		{
			SetFx(0,1);
		}
		else
		{
			SetFx(0,0);
		}
	}

}



//----------------------------------------------------------------------//
//					Sterowanie F0-F12									//
// nr		nr klawisza funkcyjnego										//
// funkcja	"1" - on, "0" - off											//
//----------------------------------------------------------------------//
void SetFx(unsigned char wyjscie,unsigned char funkcja)
{
unsigned char out,effect;
unsigned char TabAnd[]={0x80,0x01,0x02,0x04,0x08};		// Tablica do analizy ktrego wyjcia funkcyjnego dotyczy operacja

static unsigned char Cnr,Cfunkcja,Ceffect; //???

Cnr=wyjscie;
Cfunkcja=funkcja;


//Funkcje bitw:   Bit7  Bit6  Bit5  Bit4  Bit3  Bit2  Bit1  Bit0
//					-     -     -    F0    F4    F3    F2    F1
//Przykad:	CV60 = 00010000 wyjcie 0 kontrolowane funkcj F0 (Light)
//			CV61 = 00010001 wyjcie 1 kontrolowane funkcj F0 i F1.
//			CV62 = 1XXXXXXX wyjcie 2 cay czas wczone
//

//+++

//if ( (eeprom_read_byte(&eeprom.CV60_71[0]) & wyjscie)


	for (out=0; out<5; out++)
		{
		// Jesli wybrane wyjcie "out", na pozycji wybranej przez AND "wyjscie" jest "1" to zacz funkcj
		if ( ( eeprom_read_byte(&eeprom.CV60_71[out]) & TabAnd[wyjscie] ) != 0 )
			{
			effect = eeprom_read_byte( &eeprom.CV80_91[out] );		// Odczytanie efektu z eeprom
Ceffect=effect;
//			if ( (effect & (1<<CVeffect_Fwd)) != 0)					// Jeli efekt jazda do przodu
//				{
//__asm__ __volatile__( "nop" );		// UZYWANE PRZY BreakPoint
//				if (InDir != 0) continue;							// a jedzie do tyu to pomi dalsz cz
//				}
//			if ( (effect & (1<<CVeffect_Rev)) != 0)					// Jeli efekt jazda do tyu
//				{
//__asm__ __volatile__( "nop" );		// UZYWANE PRZY BreakPoint
//				if (InDir == 0) continue;							// a jedzie do przodu to pomi dalsz cz
//				}

if ( wyjscie == 0 )
{
__asm__ __volatile__( "nop" );		// UZYWANE PRZY BreakPoint
}
__asm__ __volatile__( "nop" );		// UZYWANE PRZY BreakPoint





			//--- Wczenie wybranego wyjcia ---
			if (funkcja == 1)
				{
				switch(out)
					{
					case 0:
						SetF0;
					break;
					case 2:
					break;
					case 3:
					break;
					case 4:
					break;
					}

				}
			//--- Wyczenie wybranego wyjcia ---
			else
				{
				switch(out)
					{
					case 0:
						ClrF0;
					break;
					case 2:
					break;
					case 3:
					break;
					case 4:
					break;
					}
				}
			}
		}


}



//----------------------------------------------------------------------//
// Powoli zatrzymuje lokomotywe
//----------------------------------------------------------------------//
void Hamuj()
{
	Speed=0;
}


//----------------------------------------------------------------------//
// Wycza natychmiastowo silnik
//----------------------------------------------------------------------//
void Stop()
{
	Speed=0;
	Aspeed=0;
}


//----------------------------------------------------------------------//
// Natychmiastowo maxymalna predko silnika
//----------------------------------------------------------------------//
void SpeedMax()
{
	Speed = 255;					// Prdko maksymalna
	Aspeed = 255;					//  Docelowa = aktualnej
}


//----------------------------------------------------------------------//
// Wykonuje rozkaz
//----------------------------------------------------------------------//
void execute_command(unsigned char adres,unsigned char komenda)
{

	//----------------------------------------------------------------------//
	//					komendy dla wszystkich dekoderw (adres=0)			//
	//----------------------------------------------------------------------//
	if ( (adres == 0x00) && ( komenda == 0x00 ) )			// Reset do wszystkich dekoderw
	{
		SystemInit();										// Init peryferii
		Stop();												// Wycz silnik
		TimeOutRst = (20/DivTim)+1;							// Timer na 20 ms
	}



	if ( (adres == 0x00) && ( (komenda & 0xC0) == 0xC0) )	// Stop do wszystkich dekoderw
	{
		Hamuj();											// Silnik STOP
	}



//- register mode - stara metoda: centralka wysya komendy do adresw od 120 do 127.
//   Wysanie do 120 programuje CV1, 121-CV2, 122-CV3 a do 127-CV8
	//----------------------------------------------------------------------//
	//					komendy Regiser Mode (adresy 120-127)				//
	//----------------------------------------------------------------------//


	//----------------------------------------------------------------------//
	//					komendy PGM Mode (adresy 120-125)					//
	//----------------------------------------------------------------------//
	PgmMode(adres,komenda);


	//----------------------------------------------------------------------//
	//					komendy dla zgodnego adresu							//
	//----------------------------------------------------------------------//
	if ( adres == CV1_adr )
		{
		if ( ( CV29_Cfg & (1<<CV29_Dir) ) != 0)		//Jeli CV29 zamieniony kierunek to zamieniaj komedy $40 z $60
			{
			switch ( komenda & 0xE0 )
				{
				case (0x40):
					komenda |= 0x20;
				break;
				case (0x60):
					komenda &= ~(0x20);
				break;
				}
			}
		switch ( komenda & 0xE0 )	// Analizuj 3 najstarsze bity
			{
			case (0x00):									//--- %000 Komendy kontrolujce dekoder oraz jazd w skadzie
			break;
			case (0x20):									//--- %001 Zaawansowane komendy
				if ( (komenda & 0x1F) == 0x1F )				//		   Jazda w 128 stopniach predkoci
					{
					SetPower128(dana1TMP);
					}
				if ( (komenda & 0x1F) == 0x1E )				//		   Ograniczenie stopni prdkoci
					{
					//??? bit 7 "dana1"; 1 - wczenie ograniczenia, 0 -wyczenie
					//    bity 0..5 - stopnie ograniczenia (32 kroki)
					}
			break;
			case (0x40):									//--- %010 (Prdko dla jazdy w ty) ---
				SetPower32(komenda);
				SetDirP();				// Zmiana musi by po SetPower (zmiana musi byc blokowana)
				SetLight(komenda);
			break;
			case (0x60):									//--- %011 (Prdko dla jazdy w przd) ---
				SetPower32(komenda);
				SetDirN();				// Zmiana musi by po SetPower (zmiana musi byc blokowana)
				SetLight(komenda);
			break;
			case (0x80):									//--- %100 (pierwsza grupa funkcji: F1..F4)
				// Komenda posiada format 100DDDDD
				// Komenda pierwszej grupy funkcji steruje do 5 zewntrznymi funkcjami (funkcje FL i F1-F4).
				// Bity 0-3 powinny definiowa warto funkcji F1-F4, gdzie funkcja F1 kontrolowana jest przez bit 0
				// oraz funkcja F4 kontrolowana jest przez bit 3. Warto "1" powinna oznacza, e funkcja jest "wczona",
				// a warto "0" powinna oznacza, e funkcja jest "wyczona". Jeeli bit 1 z CV29 ma warto jeden (1),
				// to bit 4 kontroluje funkcj FL, w przeciwnym wypadku bit 4 nie ma znaczenia.
				GrupaF0_F4 = komenda & 0x1F;
			break;
			case (0xA0):									//--- %101 (droga grupa funkcji: F5..F12)
				// Komenda posiada format 101SDDDD
				// Komenda drugiej grupy funkcji steruje do 8 zewntrznymi funkcjami (F5-F12).
				// Bit 4 definiuje uycie bitw 0-3. Jeeli bit 4 (S) jest "1",
				// to bity 0-3 (DDDD) powinny definiowa wartoci funkcji F5-F8,
				// gdzie funkcja F5 kontrolowana jest przez bit 0 oraz funkcja F8 kontrolowana jest przez bit 3.
				// Jeeli bit 4 (S) jest "0", to bity 0-3 (DDDD) powinny definiowa wartoci funkcji F9-F12,
				// gdzie funkcja F9 kontrolowana jest przez bit 0 oraz funkcja F12 kontrolowana jest przez bit 3.
				// Warto "1" powinna oznacza, e funkcja jest "wczona", a warto "0" powinna oznacza,
				// e funkcja jest "wyczona".
				if ( (komenda & 0x10) != 0)
					{
					GrupaF5_F8 = komenda & 0x0F;
					}
				else
					{
					GrupaF9_F12 = komenda & 0x0F;
					}
			break;
			case (0xC0):									//--- %110 	Komendy dodatkowe
			break;
			case (0xE0):									//--- %111 	Instrukcje dostpu do CV
				if ( (komenda & 0xF0) == 0xF0)				//			Wersja krtka
					{
					if (komenda != 0xF0) SetCv( (komenda & 0x0F), dana1);	// Jesli komenda nie dotyczy adresu 1 to wykonaj j
//Dostp do CV - wersja krtka
// Komenda ma format:
// 1111CCCC 0 DDDDDDDD
//
// Warto DDDDDDDD jest umieszczana w CV okrelonym przez CCCC wg nastpujcej tabelki:
// CCCC=0000 - nie nalezy uy
// CCCC=0010 - CV3 - prdko przyspieszania
// CCCC=0011 - CV4 - prdko zwalniania
//
// Pozostae wartoci CCCC s zarezerwowane na przyszo
					}
//Dostp do CV - wersja duga
// Wersja duga pozwala manipulowa wszystkimi CV. Komenda nie dziaa, jezeli jest wysyana na adres skadu.
// Format komendy jest nastpujcy:
// 1110CCAA 0 AAAAAAAA 0 DDDDDDDD
//
// Adres CV jest umieszczony w 10 bitach A. Do podanego adresu naley doda 1. Czyli, aby zaadresowac CV1 nalezy poda "00 00000000".
//
// CC definiuje typ instrukcji:
//  CC=00 - zarezerwowane na przyszo
//  CC=01 - weryfikuj
//  CC=11 - zapisz
//  CC=10 - manipulacja na bitach
//
// Dla CC=01 - weryfikuj. Jeeli podana warto DDDDDDDD jest rwna wartoci w CV Dekoder powinien odpowiedziec wartoci CV
// poprzez komend 'Odpowied z dekodera' (RailCom).
// Dla CC=11 - zapisz. Warto DDDDDDDD jest zapisywana do CV o adresie AAAAAAAAAA. Dwa idetyczne komendy musz by otrzymane,
// aby wykonac zapis. Komendy nie musza by jedna za drug, ale otrzymanie jakiejkolwiek innej komendy (w tym rozgaszanej)
// przerywa operacj zapisu.
// Dla CC=10 - manipulacja na Bitach. Drugi bajt jest interpretowany jako 111CDAAA: gdzie AAA - numer bitu do zmiany w CV,
// D - wartoc bitu do zweryfikowania lub zapisania, C oznacza: "1" - zapis, "0" - weryfikacja.
		//		if ( (komenda & 0xF0) == 0xE0)				//			Wersja Duga
		//			{
		//			CV[ ((komenda & 3)<<8)+dana1 ] = dana2;
		//			}
			break;
			}
		}

}



//----------------------------------------------------------------------------------//
// Paged mode - rozwinicie metody Register: centralka wysya rozkaz na adres 125	//
//  podajc jako warto numer rzeczywistego CV podzielony przez 4;					//
//  po czym podaje na 120,121,122 lub 123 (numer CV modulo 4) warto do wpisania. 	//
//----------------------------------------------------------------------------------//
void PgmMode(unsigned char adres, unsigned char komenda)
{
unsigned char static MemAdrMod4;

	if ( TimeOutRst == 0 ) return;		// Jeli po RST minelo wiecej niz 20ms to zlewaj tryb programowania
	#if Accesory == 1					// Jeli dekoder akcesorii
		//??? Port Serwice jako wejcie z podciganiem
		if ( Serwice != 0 ) return;		// to dodatkowo sprawdzaj stan pinu Serwice
		//??? Port Serwice jako wyjcie
	#endif

	if ( adres == 125 ) MemAdrMod4 = komenda-1;		// Zapamitanie adresu modulo 4
	if ( adres == 120 )
		{
		SetCv( ( (MemAdrMod4<<2) + 0 ), komenda );	// Zapis do CV i eeprom
		}
	if ( adres == 121 )
		{
		SetCv( ( (MemAdrMod4<<2) + 1 ), komenda );	// Zapis do CV i eeprom
		}
	if ( adres == 122 )
		{
		SetCv( ( (MemAdrMod4<<2) + 2 ), komenda );	// Zapis do CV i eeprom
		}
	if ( adres == 123 )
		{
		SetCv( ( (MemAdrMod4<<2) + 3 ), komenda );	// Zapis do CV i eeprom
		}
}


//----------------------------------------------------------------------//
// 				Zapis rejestru CV i EEprom								//
//----------------------------------------------------------------------//
void SetCv(unsigned char adres, unsigned char wartosc)
{
unsigned char cSREG;

	adres++;		// Adres w DCC jest zmiejszony o 1

	switch( adres )
	{
		case (  1 ):
			CV1_adr		= wartosc & CV1_Mask;		// CV1 - adres lokomotywy (0..127)
			cSREG = SREG;												// Zapamietaj stan znacznika I (przerwa)
			eeprom_write_byte( &eeprom.CV1_adr, (uint8_t)wartosc );		// Zapis eeprom (kasuje I - przerwania)
			SREG = cSREG;												// Odtwrz stan znacznika I (przerwa)
		break;
		case (  2 ):
			CV2_MinV		= wartosc & CV2_Mask;	// CV2 - min napiecie (0..127)
			cSREG = SREG;												// Zapamietaj stan znacznika I (przerwa)
			eeprom_write_byte( &eeprom.CV2_MinV, (uint8_t)wartosc );		// Zapis eeprom (kasuje I - przerwania)
			SREG = cSREG;												// Odtwrz stan znacznika I (przerwa)
		break;
		case (  3 ):
			CV3_rozped		= wartosc & CV3_Mask;	// CV3 - czas rozpedzania (0..15)
			cSREG = SREG;												// Zapamietaj stan znacznika I (przerwa)
			eeprom_write_byte( &eeprom.CV3_rozped, (uint8_t)wartosc );		// Zapis eeprom (kasuje I - przerwania)
			SREG = cSREG;												// Odtwrz stan znacznika I (przerwa)
		break;
		case (  4 ):
			CV4_hamow		= wartosc & CV4_Mask;	// CV4 - czas hamowania (0..15)
			cSREG = SREG;												// Zapamietaj stan znacznika I (przerwa)
			eeprom_write_byte( &eeprom.CV4_hamow, (uint8_t)wartosc );		// Zapis eeprom (kasuje I - przerwania)
			SREG = cSREG;												// Odtwrz stan znacznika I (przerwa)
			KorektaCV4();							// Obliczenia dla staej drogi hamowania
		break;
		case (  5 ):
			CV5_MaxV		= wartosc | CV5_Mask;	// CV5 - max napicie (128..255)
			cSREG = SREG;												// Zapamietaj stan znacznika I (przerwa)
			eeprom_write_byte( &eeprom.CV5_MaxV, (uint8_t)wartosc );		// Zapis eeprom (kasuje I - przerwania)
			SREG = cSREG;												// Odtwrz stan znacznika I (przerwa)
		break;
		case ( 8 ):
			if ( wartosc == 8 ) { Treset(); }		// CV8 - Ustawienia fabryczne gdy do CV8 wpiszemy 8
		break;
		case ( 9 ):
			CV9_Fpwm		= wartosc | CV9_Mask;	// CV9 - Czstotliwoc PWM'a
			SetTCCR1( CV9_Fpwm );
			cSREG = SREG;												// Zapamietaj stan znacznika I (przerwa)
			eeprom_write_byte( &eeprom.CV9_Fpwm, (uint8_t)wartosc );		// Zapis eeprom (kasuje I - przerwania)
			SREG = cSREG;												// Odtwrz stan znacznika I (przerwa)
		break;
		case ( 11 ):
			CV11_OverTime	= wartosc & CV11_Mask;	// CV11 - czas w 8ms od braku transmisji do wyczenia silnika lub przejscia na jazd analogow
			cSREG = SREG;												// Zapamietaj stan znacznika I (przerwa)
			eeprom_write_byte( &eeprom.CV11_OverTime, (uint8_t)wartosc );		// Zapis eeprom (kasuje I - przerwania)
			SREG = cSREG;												// Odtwrz stan znacznika I (przerwa)
		case ( 27 ):
			CV27_ABC		= wartosc;
			cSREG = SREG;												// Zapamietaj stan znacznika I (przerwa)
			eeprom_write_byte( &eeprom.CV27_ABC, (uint8_t)wartosc );		// Zapis eeprom (kasuje I - przerwania)
			SREG = cSREG;												// Odtwrz stan znacznika I (przerwa)
		break;
		case ( 29 ):
			CV29_Cfg		= wartosc;				// CV29 - konfiguracja,
			cSREG = SREG;												// Zapamietaj stan znacznika I (przerwa)
			eeprom_write_byte( &eeprom.CV29_Cfg, (uint8_t)wartosc );		// Zapis eeprom (kasuje I - przerwania)
			SREG = cSREG;												// Odtwrz stan znacznika I (przerwa)
		break;
		case ( 134 ):
			CV134_ABC		= wartosc & CV134_Mask;
			cSREG = SREG;												// Zapamietaj stan znacznika I (przerwa)
			eeprom_write_byte( &eeprom.CV134_ABC, (uint8_t)wartosc );		// Zapis eeprom (kasuje I - przerwania)
			SREG = cSREG;												// Odtwrz stan znacznika I (przerwa)
		break;
		case ( 136 ):
			CV136_ABC		= wartosc & CV136_Mask;
			cSREG = SREG;												// Zapamietaj stan znacznika I (przerwa)
			eeprom_write_byte( &eeprom.CV136_ABC, (uint8_t)wartosc );		// Zapis eeprom (kasuje I - przerwania)
			SREG = cSREG;												// Odtwrz stan znacznika I (przerwa)
		break;

		default:		// Jeli adres resjstru nie znaduje sie na w/w licie to nie dawaj potwierdzenia
			return;
		break;
	}

	//--- Generowanie potwierdzenia (impuls 60 ms) ---
	SetF0;										// Wcz na chwil wiata
	SpeedMax();									// i silnik
	Utimer = 60/DivTim;
	while(1) { if (Utimer == 0) break; }		// Petla opozniajaca
	Stop();										// Wycz silnik
	ClrF0;										// i oswietlenie

}




//----------------------------------------------------------------------//
// 				Init Systemu, silniki stop, odczyt eeprom				//
//----------------------------------------------------------------------//
void SystemInit()
{
unsigned char x;


	Stop();											// Silnik Stop

	CV1_adr			= eeprom_read_byte(&eeprom.CV1_adr) & CV1_Mask;		// CV1 - adres lokomotywy
	CV2_MinV		= eeprom_read_byte(&eeprom.CV2_MinV) & CV2_Mask;	// CV2 - min napiecie
	CV3_rozped		= eeprom_read_byte(&eeprom.CV3_rozped) & CV3_Mask;	// CV3 - czas rozpedzania
	CV4_hamow		= eeprom_read_byte(&eeprom.CV4_hamow) & CV4_Mask;	// CV4 - czas hamowania
	CV5_MaxV		= eeprom_read_byte(&eeprom.CV5_MaxV) | CV5_Mask;	// CV5 - max napicie
	CV9_Fpwm		= eeprom_read_byte(&eeprom.CV9_Fpwm) & CV9_Mask;	// CV9 - Czstotliwoc PWM'a
	CV11_OverTime	= eeprom_read_byte(&eeprom.CV11_OverTime) &  CV11_Mask;	// ustawiamy timer przejcia na jazd analogow
	CV27_ABC		= eeprom_read_byte(&eeprom.CV27_ABC);
	CV29_Cfg		= eeprom_read_byte(&eeprom.CV29_Cfg);				// CV29 - konfiguracja,
	CV134_ABC		= eeprom_read_byte(&eeprom.CV134_ABC) & CV134_Mask;
	CV136_ABC		= eeprom_read_byte(&eeprom.CV136_ABC) & CV136_Mask;

	KorektaCV4();									// Obliczenia dla staej drogi hamowania
	SetTCCR1( CV9_Fpwm );							// Ustawienie PWM'a
	TimeOutTrans = CV11_OverTime;					// Czas przejscia na analog

//????	for (x=0; x <= 12; x++){ SetFx(x,0); }			// Wyczenie F0..F12

}



//----------------------------------------------------------------------//
// 				Przywrocenie ustawien fabrycznych i init				//
//----------------------------------------------------------------------//
void Treset()
{
unsigned char cSREG;

	cSREG = SREG;					// Zapamietaj stan znacznika I (przerwa)

	eeprom_write_byte( &eeprom.CV1_adr, defCV1 );
	eeprom_write_byte( &eeprom.CV2_MinV, defCV2);
	eeprom_write_byte( &eeprom.CV3_rozped, defCV3 );
	eeprom_write_byte( &eeprom.CV4_hamow, defCV4 );
	eeprom_write_byte( &eeprom.CV5_MaxV, defCV5 );
	eeprom_write_byte( &eeprom.CV9_Fpwm, defCV9 );
	eeprom_write_byte( &eeprom.CV11_OverTime, defCV11 );
	eeprom_write_byte( &eeprom.CV27_ABC, defCV27 );
	eeprom_write_byte( &eeprom.CV29_Cfg, defCV29 );
	eeprom_write_byte( &eeprom.CV134_ABC, defCV134 );
	eeprom_write_byte( &eeprom.CV136_ABC, defCV136 );

	SREG = cSREG;					// Odtwrz stan znacznika I (przerwa)
	SystemInit();					// Wprowadzenie zmian w ycie
}



//----------------------------------------------------------------------//
//	Obliczenie wspoczyynika korekty CV4 dla staej drogi hamowania		//
//----------------------------------------------------------------------//
void KorektaCV4()
{
unsigned int CzasHamowania;

	CzasHamowania = 256 / krok_na_okres / CV4_hamow * DivTim;
//??? Wywietlic CzasHamowania

//Aspeed = 248;
	CV4_Korrect = CzasHamowania / Aspeed * krok_na_okres / CV4_hamow / DivTim;

//??? Wywietlic CV4_Korrect

}


//***********************************************************************//
//*							End Of Code									*//
//***********************************************************************//
