


//---------------- Efekt spawania --------------------------
#define	PracaMin		60				// sek
#define	PracaMax		180
#define	PrzerwaMin		120
#define	PrzerwaMax		240


#define	SpawaMin		1000			// ms
#define	SpawaMax		5000
#define	NieSpawaMin		2000
#define	NieSpawaMax		9000	

#define	BlyskMin		5				// ms
#define	BlyskMax		100





/*
//---------------- Efekt burzy --------------------------
#define	PracaMin		2				// sek
#define	PracaMax		4
#define	PrzerwaMin		30
#define	PrzerwaMax		240

#define	SpawaMin		50				// ms
#define	SpawaMax		200
#define	NieSpawaMin		5000
#define	NieSpawaMax		10000	

#define	BlyskMin		5				// ms
#define	BlyskMax		20
*/



#define FlashLedOn		PORTB |=  (1 << PB3 )		
#define FlashLedOff		PORTB &= ~(1 << PB3 )
#define FlashLedNeg		PORTB ^=  (1 << PB3 )





//*******************************************************************************//
//* 				Pliki doczane												*//
//*******************************************************************************//
#include <stdlib.h>									// Standardowa C
//#include <math.h> 								// Zmiennoprzecinkowe
#include <avr/io.h>									// IO
#include <avr/sfr_defs.h>							// SFR, _BV(bit)
#include <avr/pgmspace.h>							// Flash
#include <avr/interrupt.h>							// wektory IRQ
#include <avr/wdt.h> 								// WDG
#include <avr/eeprom.h>								// Eeprom
#include <compat/deprecated.h>						// sbi, cbi, inb, outb, outp
#include <util/delay.h>								// Delay ms i us
//#include <util/setbaud.h>							// Uart
//#include <util/crc16.h>							// Crc16, Xmodem, Dallas
#define ebi(port,bit) ( port ^= (1 << (bit)))		// Negowanie bitu na porcie
#define CODE PROGMEM								// Stale w Flash dla parametru CODE i PROGMEM
#define NOINIT __attribute__ ((section(".noinit")))
#define nop()	__asm__ __volatile__( "nop" )		// Wstawia rozkaz NOP do kodu





//-------------------------- Alerty  ------------------------------//
#ifndef F_CPU
	#error "Nie zdefiniowany zegar procesora"
#endif


CODE char versjaTXT[] = "Versja: ";
CODE char versja[] = "1.0";							// Wersja programu
CODE char compilied[] = "Skompilowano: ";
CODE char dzien[] = __DATE__;						// Data kompilacji
CODE char czas[] = __TIME__;						// Czas kompilacji
CODE char autor[] = "S.Skrzynski <www.r-mik.eu>";	// Autor




int _rand(unsigned int zakres);
int Los(int zakres);




//*******************************************************************************//
//* 				Program gwny												*//
//*******************************************************************************//
int main()
{
unsigned long cnt_ms,cnt_s,Tpracy,Tpauzy,Tflash;


	wdt_enable( WDTO_250MS);					// Blokuje IRQ !!!
	DDRB = 0xFF;




	//***********************************************************//
	//* 			Petla gwna								*//
	//***********************************************************//
	while(1)
		{
		//--- Do pracy ---
PORTB &= ~(1<<PB1);
		Tpracy = PrzerwaMin + ( Los(PrzerwaMax-PrzerwaMin) );
	//	Tpracy *= 1000;			// !!!??? zastpic przez przeswanie "<< 10" ( * 1024)
		Tpracy <<= 10;			// !!!???
		cnt_s = 0;
		while( cnt_s < Tpracy )
			{
			//--- Czas spawania ---
PORTB &= ~(1<<PB0);
			Tpauzy = SpawaMin + ( Los(SpawaMax-SpawaMin) );				// Czas spawania
			cnt_ms = 0;
			while ( cnt_ms < Tpauzy )
				{
				wdt_reset();
				Tflash = BlyskMin + ( Los(BlyskMax-BlyskMin) );			// Wylosowanie czasu trwania bysku (1..64ms)
				_delay_ms( Tflash );
				FlashLedNeg;
				cnt_ms += Tflash;
				cnt_s += Tflash;
				}
			//--- Przerwa w spawaniu ---
PORTB |= (1<<PB0);
			FlashLedOff;
			cnt_ms=0;
			Tpauzy = NieSpawaMin + ( Los(NieSpawaMax-NieSpawaMin) );	// Czas przerwy w spawaniu
			while ( cnt_ms < Tpauzy )
				{
				wdt_reset();
				_delay_ms(1);
				cnt_ms++;
				cnt_s ++;
				}
			}
		//--- Przerwa sniadaniowa ---
PORTB |= (1<<PB1);
		Tpracy = PrzerwaMin + ( Los(PrzerwaMax-PrzerwaMin) );
	//	Tpracy *= 1000;			// !!!??? zastpic przez przeswanie "<< 10" ( * 1024)
		Tpracy <<= 10;			// !!!???
		cnt_s = 0;
		while( cnt_s < Tpracy )
			{
			wdt_reset();
			_delay_ms(1);
			cnt_s ++;
			}
		}

}






//-----------------------------------------------------------------------------
// Generuje liczbe pseudolosowa
//-----------------------------------------------------------------------------
int Los(int zakres)
{
	return( rand() % zakres);
//	return ( _rand(zakres) );
}


//-----------------------------------------------------------------------------
// Generuje liczbe pseudolosowa funkcja LFSR
//-----------------------------------------------------------------------------
int _rand(unsigned int zakres)
{
static unsigned long lfsr = 1;
unsigned int reszta=1;

	if 		(zakres < 	4)		{ reszta=0x0003; }
	else if (zakres < 	8)		{ reszta=0x0007; }
	else if (zakres < 	16)		{ reszta=0x000F; }
	else if (zakres < 	32)		{ reszta=0x001F; }
	else if (zakres < 	64)		{ reszta=0x003F; }
	else if (zakres < 	128)	{ reszta=0x007F; }
	else if (zakres < 	256)	{ reszta=0x00FF; }
	else if (zakres < 	512)	{ reszta=0x01FF; }
	else if (zakres < 	1024)	{ reszta=0x03FF; }
	else if (zakres < 	2048)	{ reszta=0x07FF; }
	else if (zakres < 	4096)	{ reszta=0x0FFF; }
	else if (zakres < 	8192)	{ reszta=0x1FFF; }
	else if (zakres < 	16384)	{ reszta=0x3FFF; }
	else if (zakres < 	32768)	{ reszta=0x7FFF; }
	else						{ reszta=0xFFFF; }	// Przekroczony zakres !!!


	while ( 1 )			// Losuj az wylosuje liczb z zadanego zakresu
		{
    	lfsr = (lfsr >> 1) ^ (-(lfsr & 1) & 0xd0000001); 
		if ( (lfsr & reszta) <= zakres ){ break; }
		}
		return( lfsr );


}


